Subject: bug#29157: 25.3; Eshell parsing fails sometimes, e.g. "date" and "sed"

From: Eli Zaretskii <[email-masked]>
Date: Sat, 25 Nov 2017 21:29:08 +0200

> From: Pierre Neidhardt <[email-masked]>
> Cc: Noam Postavsky <[email-masked]>, [email-masked]
> Date: Sat, 25 Nov 2017 18:54:51 +0100
> 
> > 	~/git/emacs/branch $ date 42
> > 	Wed Dec 31 19:00:42 1969
> > But
> > 	~/git/emacs/branch $ *date 42
> > 	/bin/date: invalid date ‘42’
> >
> > So I'm not sure such a naïve solution is TRT in this case, because we
> > are losing valuable features by doing that, and those features are not
> > just an accident, they were intentionally included in Eshell.
> 
> I think you are right.  I did not know that eshell/date could be used
> this way.

Not just eshell/date: many Eshell built-ins behave like that, and they
do that on purpose.

> The issue here is mostly my lack of awareness about what is an Elisp
> command and what is a system program.

Why do you need to know that?

If you want to know that so you could always get the same responses as
from another system shell, then perhaps we should have an option to
tell Eshell to always invoke an external program (maybe we already
have such an option, but I couldn't find it).

> Maybe having different syntax highlighting for the "verb" depending on
> whether it's a system program or an Elisp command would help avoiding
> the pitfall.

Isn't it true that a verb that doesn't begin with a '*' is _never_ a
system program in Eshell?